package com.huiju.estateagents.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.huiju.estateagents.base.ResponseBean;
import com.huiju.estateagents.entity.TaChannel;
import com.huiju.estateagents.entity.TaPersonBuilding;
import com.huiju.estateagents.excel.ActivityStatistics.ChannelAddRegistNum;
import com.huiju.estateagents.excel.ActivityStatistics.ChannelVisitNum;
import com.huiju.estateagents.excel.ActivityStatistics.ChannelVisitPersonNum;
import com.huiju.estateagents.excel.ActivityStatistics.TsChannelDaily;

import java.time.LocalDate;
import java.util.List;

/**
 * <p>
 *   服务类
 * </p>
 *
 * @author jobob
 * @since 2019-09-17
 */
public interface TaChannelService extends IService<TaChannel> {

    /**
     * 渠道引进客户统计
     * @param pageNum
     * @param pageSize
     * @param orgId
     * @param startDate
     * @param endDate
     * @param channelType
     * @param buildingId
     * @return
     */
    ResponseBean getChannelIntroductionList(Integer pageNum, Integer pageSize, Integer orgId, LocalDate startDate, LocalDate endDate, String channelType, String buildingId, Integer channelId,String sortField,String sortOrder, List<TaPersonBuilding> taPersonBuildings);

    /**
     * 获取注册用户列表
     * @param pageNum
     * @param pageSize
     * @param orgId
     * @param channelId
     * @param targetId
     * @param targetType
     * @param buildingId
     * @return
     */
    ResponseBean getNewuserList(Integer pageNum, Integer pageSize, Integer orgId, Integer channelId, String targetId, String targetType, String buildingId, LocalDate startDate, LocalDate endDate);

    /**
     * 获取渠道下的访问次数列表
     * @param pageNum
     * @param pageSize
     * @param orgId
     * @param channelId
     * @param targetId
     * @param targetType
     * @param buildingId
     * @return
     */
    ResponseBean getVisitNumList(Integer pageNum, Integer pageSize, Integer orgId, Integer channelId, String targetId, String targetType, String buildingId, LocalDate startDate, LocalDate endDate);

    /**
     * 获取渠道下的访问人数列表
     * @param pageNum
     * @param pageSize
     * @param orgId
     * @param channelId
     * @param targetId
     * @param targetType
     * @param buildingId
     * @return
     */
    ResponseBean getPersonNumList(Integer pageNum, Integer pageSize, Integer orgId, Integer channelId, String targetId, String targetType, String buildingId, LocalDate startDate, LocalDate endDate);

    /**
     * 导出
     * @param orgId
     * @param startDate
     * @param endDate
     * @param channelType
     * @param buildingId
     * @param channelId
     * @return
     */
    List<TsChannelDaily> getChannelIntroductionListExport(Integer orgId, LocalDate startDate, LocalDate endDate, String channelType, String buildingId, Integer channelId);

    /**
     * 导出
     * @param orgId
     * @param channelId
     * @param targetId
     * @param targetType
     * @param buildingId
     * @return
     */
    List<ChannelAddRegistNum> getNewuserListExport(Integer orgId, Integer channelId, String targetId, String targetType, String buildingId, LocalDate startDate, LocalDate endDate);

    /**
     * 导出
     * @param orgId
     * @param channelId
     * @param targetId
     * @param targetType
     * @param buildingId
     * @return
     */
    List<ChannelVisitNum> getVisitNumListExport(Integer orgId, Integer channelId, String targetId, String targetType, String buildingId, LocalDate startDate, LocalDate endDate);

    /**
     * 导出
     * @param orgId
     * @param channelId
     * @param targetId
     * @param targetType
     * @param buildingId
     * @return
     */
    List<ChannelVisitPersonNum> getPersonNumListExport(Integer orgId, Integer channelId, String targetId, String targetType, String buildingId, LocalDate startDate, LocalDate endDate);
}
